<template>
    <div id="selectedCard" class="container center">
        <table class="text-center center">
            <tr>
                <td>
                    <div v-if="beforeHintAdded" class="form-floating">
                        <textarea v-model="hint" class="form-control" placeholder="Write a hint here" id="floatingTextarea"></textarea>
                        <label for="floatingTextarea">Hint for the chosen card</label>
                        <br />
                        <button class="btn btn-info" v-on:click="saveHint(hint)">OK</button>
                    </div>
                    <div v-if="!beforeHintAdded">
                       <h2>Wait for other players selections</h2>
                       <h3>Your hint:
                       <span id="hint">{{ hint }}</span> </h3> 
                    </div>
                </td>
                <td>
                    <ChosenCard :chosenCardId=chosenCardId class="column d-flex justify-content-center"></ChosenCard>
                </td>
                <td>
                    <Points></Points>
                </td>
            </tr>
        </table>
         <br />
         <br />
         <RemainingCards v-bind:playerId="playerId"></RemainingCards>
    </div>
</template>

<script>
    import axios from 'axios';
    import RemainingCards from './RemainingCards.vue';
    import ChosenCard from './ChosenCard.vue';
    import Points from './Points.vue';
    export default {
        name: 'selectedCard',
        components: {
            RemainingCards,
            ChosenCard,
            Points
        },
        data: function () {
            return {
                cardFileName: '',
                playerId: this.$route.params.playerId,
                gameId: this.$route.params.gameId,
                roundId: this.$route.params.roundId,
                chosenCardId: this.$route.params.cardId,
                hint: '',
                beforeHintAdded: true,
                polling: null,
                allGuessed: false
            }
        },
        methods: {
            saveHint(hint) {
                axios.post("https://localhost:44361/api/card/round/" + this.roundId + "/cardDescription", {
                    hint: hint,
                    roundId: this.roundId
                })
                    .then(this.beforeHintAdded = false);
            },
            checkIfAllGuessesDone() {
                 this.polling = setInterval(() => {
                    axios.get("https://localhost:44361/api/round/" + this.roundId + "/guessesdone")
                        .then(response => this.allGuessed = response.data);
                    if (this.allGuessed) {
                        this.$router.push({ name: 'roundSummary', params: this.defineParams() });
                    }
                }, 3000);
            },
            defineParams() {
                return {
                    playerId: this.$route.params.playerId,
                    gameId: this.$route.params.gameId,
                    roundId: this.$route.params.roundId
                }
            }
        },
        beforeDestroy() {
            clearInterval(this.polling);
        },
        created: function () {
            this.checkIfAllGuessesDone();
        }
    }
</script>

<style scoped>
    .center {
  margin-left: auto;
  margin-right: auto;
}
    .myCell {
        text-align: center;
    }
    td {
        padding: 20px;
    }
    #hint {
        font-weight: bold;
    }
</style>
